# Orchest

```{title} Orchest Docs

```

```{eval-rst}
.. meta::
   :description: Orchest is a tool for building data pipelines, made to be easy to use. This is the Orchest documentation index.
```

**Orchest is a tool for building data pipelines, made to be easy to use.**

```{tip}
👉 Get started with the {ref}`quickstart <quickstart>`!
```

```{figure} img/pipeline-editor.png
:align: center
:alt: Visualizing a data pipeline in Orchest.
:width: 800

💡 Watch the [video](https://vimeo.com/764866337) to learn more.
```

- Visually construct pipelines through Orchest user-friendly UI
- Code in Notebooks and scripts ({ref}`quickstart <quickstart>`)
- Run any subset of a pipeline directly or schedule it to run periodically ({ref}`jobs <jobs>`)
- Easily define your dependencies to run on any machine ({ref}`environments <environments>`)
- Spin up services whose lifetime spans across the entire pipeline run ({ref}`services <services>`)
- Version your projects using git ({ref}`projects <projects>`)

```{toctree}
:hidden: true
:maxdepth: 1

getting_started/index
```

```{toctree}
:hidden: true
:maxdepth: 1

fundamentals/index
```

```{toctree}
:hidden: true
:maxdepth: 1

reference/index
```

```{toctree}
:hidden: true
:maxdepth: 1

development/index
```
