/*
Copyright 2022 The orchest Authors.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1alpha1 "github.com/orchest/orchest/services/orchest-controller/pkg/apis/orchest/v1alpha1"
	scheme "github.com/orchest/orchest/services/orchest-controller/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// OrchestClustersGetter has a method to return a OrchestClusterInterface.
// A group's client should implement this interface.
type OrchestClustersGetter interface {
	OrchestClusters(namespace string) OrchestClusterInterface
}

// OrchestClusterInterface has methods to work with OrchestCluster resources.
type OrchestClusterInterface interface {
	Create(ctx context.Context, orchestCluster *v1alpha1.OrchestCluster, opts v1.CreateOptions) (*v1alpha1.OrchestCluster, error)
	Update(ctx context.Context, orchestCluster *v1alpha1.OrchestCluster, opts v1.UpdateOptions) (*v1alpha1.OrchestCluster, error)
	UpdateStatus(ctx context.Context, orchestCluster *v1alpha1.OrchestCluster, opts v1.UpdateOptions) (*v1alpha1.OrchestCluster, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.OrchestCluster, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.OrchestClusterList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.OrchestCluster, err error)
	OrchestClusterExpansion
}

// orchestClusters implements OrchestClusterInterface
type orchestClusters struct {
	client rest.Interface
	ns     string
}

// newOrchestClusters returns a OrchestClusters
func newOrchestClusters(c *OrchestV1alpha1Client, namespace string) *orchestClusters {
	return &orchestClusters{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the orchestCluster, and returns the corresponding orchestCluster object, and an error if there is any.
func (c *orchestClusters) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.OrchestCluster, err error) {
	result = &v1alpha1.OrchestCluster{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("orchestclusters").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of OrchestClusters that match those selectors.
func (c *orchestClusters) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.OrchestClusterList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.OrchestClusterList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("orchestclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested orchestClusters.
func (c *orchestClusters) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("orchestclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a orchestCluster and creates it.  Returns the server's representation of the orchestCluster, and an error, if there is any.
func (c *orchestClusters) Create(ctx context.Context, orchestCluster *v1alpha1.OrchestCluster, opts v1.CreateOptions) (result *v1alpha1.OrchestCluster, err error) {
	result = &v1alpha1.OrchestCluster{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("orchestclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(orchestCluster).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a orchestCluster and updates it. Returns the server's representation of the orchestCluster, and an error, if there is any.
func (c *orchestClusters) Update(ctx context.Context, orchestCluster *v1alpha1.OrchestCluster, opts v1.UpdateOptions) (result *v1alpha1.OrchestCluster, err error) {
	result = &v1alpha1.OrchestCluster{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("orchestclusters").
		Name(orchestCluster.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(orchestCluster).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *orchestClusters) UpdateStatus(ctx context.Context, orchestCluster *v1alpha1.OrchestCluster, opts v1.UpdateOptions) (result *v1alpha1.OrchestCluster, err error) {
	result = &v1alpha1.OrchestCluster{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("orchestclusters").
		Name(orchestCluster.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(orchestCluster).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the orchestCluster and deletes it. Returns an error if one occurs.
func (c *orchestClusters) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("orchestclusters").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *orchestClusters) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("orchestclusters").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched orchestCluster.
func (c *orchestClusters) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.OrchestCluster, err error) {
	result = &v1alpha1.OrchestCluster{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("orchestclusters").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
